# -*- coding: utf-8 -*-
"""
Created on Fri Sep  4 11:36:24 2020

@author: Igor Beloschapkin
"""

import tkinter
import subprocess
import configparser

# own code:
# from questionnaire import quest

# TODO Eventuell updatefunktion über git pull mit einbauen!

__version__ = 0.3

class App:

    def __init__(self, master):
        self.paradigmText = tkinter.sys.argv[1]
        # App.paradigmText = sys.argv[1]
        # pathOrigin = os.path.dirname(os.path.realpath(__file__))

        # TODO current working directory auf root von dieser file setzen

        # global pathSave
        # pathSave = "\\questions\\" + self.paradigmText
        # pathSave = os.getcwd() + pathSave

        config.read('config.ini')

        # Einstellung der GUI Größe
        textH = 4
        textHsmall = 2
        textW = 20

        def makeBtn(self, text, bg, command, side):
            self.button = tkinter.Button(frame, text=text, bg=bg, command=command)
            self.button.config( height = textH, width = textW )
            self.button['font'] = tkinter.font.Font(family='Helvetica', size=16, weight='bold')
            self.button.pack(side=side)
            return self.button

        def makeBtnSmall(self, text, bg, command, side):
            self.button = tkinter.Button(frame, text=text, bg=bg, command=command)
            self.button.config( height = textHsmall, width = textW )
            self.button['font'] = tkinter.font.Font(family='Helvetica', size=16, weight='bold')
            self.button.pack(side=side)
            return self.button

        frame = tkinter.Frame(master)
        frame.pack()

        # label generation
        headerText = 'PythonBCIgui V' + str(__version__) + '\n\n' + self.paradigmText + ' BCI'
        self.Lparadigm = tkinter.Label(frame, text = headerText, height = 4, width = 20)
        self.Lparadigm['font'] = tkinter.font.Font(family='Helvetica', size=16, weight='bold')
        self.Lparadigm.pack()

        # button generation
        if self.paradigmText == 'Tactile':
            self.Bfilter = makeBtn(self, "1. Filter", "lightyellow", self.btn_filter, tkinter.TOP)
            self.BtacCal = makeBtn(self, "2. Kalibrierung", "lightgreen", self.btn_tacCal, tkinter.TOP)
            self.Bp300 = makeBtn(self, "3. P300 Klassifizierung", "orange", self.btn_p300, tkinter.TOP)
            self.BtacCopy = makeBtn(self, "4. Freies Buchstabieren", "lightblue", self.btn_tacCopy, tkinter.TOP)
            self.BtacSimul = makeBtn(self, "5. Rollstuhlsimulator", "pink", self.btn_tacSimul, tkinter.TOP)
        elif self.paradigmText == 'Visual':
            self.Bfilter = makeBtn(self, "1. Filter", "lightyellow", self.btn_filter, tkinter.TOP)
            self.BvisCal = makeBtn(self, "2. Kalibrierung", "lightgreen", self.btn_visCal, tkinter.TOP)
            self.Bp300 = makeBtn(self, "3. P300 Klassifizierung", "orange", self.btn_p300, tkinter.TOP)
            self.BvisCopy = makeBtn(self, "4. Freies Buchstabieren", "lightblue", self.btn_visCopy, tkinter.TOP)
        elif self.paradigmText == 'Test':  # TODO Remove
            self.Bfilter = makeBtn(self, "1. Filter", "lightyellow", self.btn_filter, tkinter.TOP)
            self.BvisCal = makeBtn(self, "2. Kalibrierung", "lightgreen", self.btn_visCal, tkinter.TOP)
            self.Bp300 = makeBtn(self, "3. P300 Klassifizierung", "orange", self.btn_p300, tkinter.TOP)
            self.BvisCopy = makeBtn(self, "4. Freies Buchstabieren", "lightblue", self.btn_visCopy, tkinter.TOP)
            self.Btest = makeBtnSmall(self, "TEST", "green", self.btn_test, tkinter.TOP)  # TODO Remove
        else:
            print('Fehler: Bitte wählen Sie "Tactile" oder "Visual" als Argument')
            raise ValueError

        # self.Bquest = makeBtnSmall(self, "6. Fragebogen", "green", self.btn_quest, TOP)
        self.BtacConfig = makeBtnSmall(self, "Konfiguration", "gray", self.btn_config, tkinter.TOP)

        frame.rowconfigure((0,1), weight=1)  # make buttons stretch when
        frame.columnconfigure((0,2), weight=1)  # when window is resized
        # TODO Hilfestellung nach jedem Button aufploppen lassen:
        # Was tun? Wo klicken? Welche File wo laden?

    # 1. FILTER ##################################
    def btn_filter(self):
        print('Starte TactileBCIFilter.exe')
        subprocess.Popen(config['PATH']['tactilebcifilter'] + '\TactileBCIFilter.exe')

    # 2. KALIBIERUNGEN ###########################
    def btn_tacCal(self):
        print('starte taktile Kalibrierung')
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\Operator.exe', '--OnConnect', '-LOAD PARAMETERFILE TactileCalibration.prm'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\gUSBampSource.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3SignalProcessing.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3Speller.exe', '127.0.0.1'])
        # TODO Lock einführen und bei Returnwert Lock öffnen
    def btn_visCal(self):
        print('starte visuelle Kalibrierung')
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\Operator.exe', '--OnConnect', '-LOAD PARAMETERFILE gUSBamp_visual_copySpeller.prm'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\gUSBampSource.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3SignalProcessing.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3Speller.exe', '127.0.0.1'])

    # 3. P300 Classifier #########################
    def btn_p300(self):
        print('Starte P300Classifier.exe')
        subprocess.Popen(config['PATH']['bci2000'] + r'\tools\P300Classifier\P300Classifier.exe')

    # 4. COPYSPELL     ###########################
    def btn_tacCopy(self):
        print('Starte taktilen Speller')
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\Operator.exe', '--OnConnect', '-LOAD PARAMETERFILE TactileCopy.prm'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\gUSBampSource.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3SignalProcessing.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3Speller.exe', '127.0.0.1'])
    def btn_visCopy(self):
        print('Starte visuellen Speller')
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\Operator.exe', '--OnConnect', '-LOAD PARAMETERFILE gUSBamp_visual_freeSpeller.prm'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\gUSBampSource.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3SignalProcessing.exe', '127.0.0.1'])
        subprocess.Popen([config['PATH']['bci2000'] + r'\prog\P3Speller.exe', '127.0.0.1'])

    # 5. WHEELCHAIR SIMULATOR     ###########################
    def btn_tacSimul(self):
        print('Starte Wheelchair Simulator')
        # TODO Starte Wheelchair Simulator Programm
        # subprocess.Popen([pathBci2000 + '\prog\Operator.exe', '--OnConnect', '-LOAD PARAMETERFILE TactileDrive.prm'])
        # subprocess.Popen([pathBci2000 + '\prog\gUSBampSource.exe', '127.0.0.1'])
        # subprocess.Popen([pathBci2000 + '\prog\P3SignalProcessing.exe', '127.0.0.1'])
        # subprocess.Popen([pathBci2000 + '\prog\P3Speller.exe', '127.0.0.1'])

    # QUESTIONNAIRE PROMPT   ###########################
    # def btn_quest(self):
        #root.destroy()
        # self.startQuestions(self.paradigmText)

    # def startQuestions(self, para):
    #     print('Starte Fragebogen')
    #     q = quest(para)
    #     q.qSatisfaction()
    #     q.qExhaustion()
    #     q.qSubjControl()
    #     q.qCtrlChange()
    #     q.save()

    # X. Settings #########################
    def btn_config(self):
        print('Konfiguration')
        tkinter.messagebox.showinfo('Konfiguration', 'Bitte wählen Sie nun den BCI2000 Ordner aus, in dem sich die Ordner "batch", "data", "icons", "parms", "prog" und "tools" befinden.')
        config['PATH']['bci2000'] = tkinter.filedialog.askdirectory()
        tkinter.messagebox.showinfo('Konfiguration', 'Bitte wählen Sie nun den Ordner aus, in dem sich die TactileBCIfilter.exe befindet.')
        config['PATH']['tactilebcifilter'] = tkinter.filedialog.askdirectory()
        config.write(open('config.ini','w'))
        # TODO Catch errors falls falsche Ordner gewählt wurden

    def btn_test(self):  # TODO Remove
        print('TEST')
        print(self.paradigmText)

    def global_close(self, window):
        print('Beenden')
        window.destroy()

config = configparser.ConfigParser()
root = tkinter.Tk()

def on_closing():
    #self.global_close(root)
    print('Beenden')
    root.destroy()

root.protocol("WM_DELETE_WINDOW", on_closing)
app = App(root)
root.mainloop()
#root.destroy() # optional;
